华为OD面试手撕算法-最大子数组和

题目描述

本题是leetcode原题(中等难度):最大子数组和

给你一个整数数组 nums ,请你找出一个具有最大和的连续子数组(子数组最少包含一个元素),返回其最大和。

子数组是数组中的一个连续部分。

思路分析

【动态规划 】当前位置的子数组最大和可以由前一个位置的结果推理出来,即当前状态可由上一个状态推出,对于这一类问题,我们都可以考虑使用动态规划来解决【墙推Carl哥的代码随想录】。

DP五部曲分析:

1)确定dp数组的下标及含义:dpi表示以numsi结尾的连续子数组最大和

2)确定递推公式:当前位置的值只能由前一个位置dpi-1推出。对于dpi-1,我们有两种选择:

① 若dpi-1 < 0:表示前i-1个元素的最大子数组和小于0,说明其对当前位置的结果有负面作用,我们选择抛弃,从当前位置重新开始,此时dpi = numsi;

② 若dpi-1>=0: 表示前i-1个元素的最大子数组和大于等于0,说明对当前位置结果有正向作用,我们选择接纳,此时dpi = dpi-1 + numsi;

故递推公式为dpi = max(numsi,dpi-1+numsi)

  1. 初始化dp:第一个位置的最大子数组和即为本身,故dp0 = nums0,其余元素均初始为0;

4)确定遍历顺序:dpi 是由dpi-1推出的,故遍历顺序为从前向后

5)举例验证dp过程

因为我们要求的是全局最大和,所以dp遍历过程中,应该用一个全局遍历记录最大值maxSum,最后返回maxSum。

代码实现

Go 复制代码
func maxSubArray(nums []int) int {
    maxSum := nums[0]
    dp := make([]int,len(nums))
    //dp初始化
    dp[0] = nums[0]
    for i := 1;i < len(nums);i++{
        dp[i] = maxVal(nums[i],dp[i-1]+nums[i])
        maxSum = maxVal(maxSum,dp[i])
    }
    return maxSum
}

func maxVal(a,b int) int{
    if a > b {
        return a
    }
    return b
}
相关推荐
程序 代码狂人1 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade2 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Aurora112 小时前
Jane Street OA 真题解析:Mastermind 猜密码与候选集筛选
面试
skytier3 小时前
昇思大模型推理:输出 logits
面试
小郎君6584 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一4 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS1004 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
丑陋小蚊子4 小时前
简历电脑上清楚,手机上字太小,先改哪里?
面试·求职招聘·大学生·简历·简历下载
shehuiyuelaiyuehao4 小时前
算法56,重排链表
数据结构·算法·链表